// $Id: nextpleaseOptions.js,v 1.16 2007/07/21 00:15:11 howie Exp $

var StringToKeyCodeMap = new Array();  
var KeyCodeToStringMap = new Array();

var NextPhrasesMap = new Array();
var PrevPhrasesMap = new Array();
var FirstPhrasesMap = new Array();
var LastPhrasesMap = new Array();

var NextImagesMap  = new Array();
var PrevImagesMap  = new Array();
var FirstImagesMap  = new Array();
var LastImagesMap  = new Array();

var DefaultNextPhrases = new Array("Next", "next", "Next >", "next >", ">", "MORE RESULTS", "Newer ", "Older topics ", "next page", "Go to the next photo in the stream");  
var DefaultPrevPhrases = new Array("Previous", "previous", "Prev", "prev", "< Previous", "< previous", 
				   "PREVIOUS RESULTS", "< Prev", "< prev", "<", "<< Prev", " Older", " Newer topics", "previous page", "Go to the previous photo in the stream");

var DefaultFirstPhrases = new Array("First", "first", "< First", "< first", "first page");
var DefaultLastPhrases = new Array("Last", "last", "Last >", "last >", "last page");

var DefaultNextImages = new Array("http://g-images.amazon.com/images/G/01/search-browse/button-more-results.gif");
var DefaultPrevImages = new Array("http://g-images.amazon.com/images/G/01/search-browse/button-previous.gif");
var DefaultFirstImages = new Array();
var DefaultLastImages = new Array();

    var DefaultNextRegEx  = "^next(\\s+\\d+)?(\\s+\\w+)?\\s*((>?>?)|\\xbb)\\s*\$";
    var DefaultPrevRegEx  = "^((<?<?)|\\xab)\\s*((prev(ious)?(\\s+\\d+)?(\\s+\\w+)?)|back)\\s*\$";
    var DefaultFirstRegEx = "^((<?<?)|\\xab)\\s*(first(\\s+\\d+)?(\\s+\\w+)?)\\s*$";
    var DefaultLastRegEx  = "^last(\\s+\\d+)?(\\s+\\w+)?\\s*((>?>?)|\\xbb)\\s*$";

var DefaultGalleryRegEx  = "(.*(?:[^\\d]|^))(\\d+)([^/]*?\\.(?:jpg|gif|bmp|png))$";

var keyBindingsChanged;

// Strip leading and trailing whitespace from
// the passed in string and return it.
function nextplease_Trim(str)
{
   return str.replace(/^\s*|\s*$/g,"");
}

function nextplease_isAlpha(str)
{
    var isAlphaRegEx = /^[a-z ]$/i;
    return isAlphaRegEx.test(str);
}

function nextplease_SetUnicharPref(prefs, aPrefName, aPrefValue)
{
   if (prefs)
   {
     try {
       var str = Components.classes["@mozilla.org/supports-string;1"]
                           .createInstance(Components.interfaces.nsISupportsString);
       str.data = aPrefValue;
       prefs.setComplexValue(aPrefName, Components.interfaces.nsISupportsString, str);
     }
     catch(e) {}
   }
}

function nextplease_GetUnicharPref(prefs, aPrefName)
{
  if (prefs)
  {
    try {
      return prefs.getComplexValue(aPrefName, Components.interfaces.nsISupportsString).data;
    }
    catch(e) {}
  }
  return "";
}

// Initialize the lookup table for key name to keycode
function nextplease_initializeStringToKeyCodeMap(map)
{
    map["Left Arrow"] = KeyEvent.DOM_VK_LEFT;
    map["Right Arrow"] = KeyEvent.DOM_VK_RIGHT;
    map["Up Arrow"] = KeyEvent.DOM_VK_UP;
    map["Down Arrow"] = KeyEvent.DOM_VK_DOWN;
    map["Page Up"] = KeyEvent.DOM_VK_PAGE_UP;
    map["Page Down"] = KeyEvent.DOM_VK_PAGE_DOWN;
    map["Home"] = KeyEvent.DOM_VK_HOME;
    map["End"] = KeyEvent.DOM_VK_END;
    map["F1"] = KeyEvent.DOM_VK_F1;
    map["F2"] = KeyEvent.DOM_VK_F2;
    map["F3"] = KeyEvent.DOM_VK_F3;
    map["F4"] = KeyEvent.DOM_VK_F4;
    map["F5"] = KeyEvent.DOM_VK_F5;
    map["F6"] = KeyEvent.DOM_VK_F6;
    map["F7"] = KeyEvent.DOM_VK_F7;
    map["F8"] = KeyEvent.DOM_VK_F8;
    map["F9"] = KeyEvent.DOM_VK_F9;
    map["F10"] = KeyEvent.DOM_VK_F10;
    map["F11"] = KeyEvent.DOM_VK_F11;
    map["F12"] = KeyEvent.DOM_VK_F12;
}

// Initialize the lookup table for keycode to keyname
function nextplease_initializeKeyCodeToStringMap(map)
{
    map[KeyEvent.DOM_VK_LEFT] = "Left Arrow";
    map[KeyEvent.DOM_VK_RIGHT] = "Right Arrow";
    map[KeyEvent.DOM_VK_UP] = "Up Arrow";
    map[KeyEvent.DOM_VK_DOWN] = "Down Arrow";
    map[KeyEvent.DOM_VK_PAGE_UP] = "Page Up";
    map[KeyEvent.DOM_VK_PAGE_DOWN] = "Page Down";
    map[KeyEvent.DOM_VK_HOME] = "Home";
    map[KeyEvent.DOM_VK_END] = "End";
    map[KeyEvent.DOM_VK_F1] = "F1";
    map[KeyEvent.DOM_VK_F2] = "F2";
    map[KeyEvent.DOM_VK_F3] = "F3";
    map[KeyEvent.DOM_VK_F4] = "F4";
    map[KeyEvent.DOM_VK_F5] = "F5";
    map[KeyEvent.DOM_VK_F6] = "F6";
    map[KeyEvent.DOM_VK_F7] = "F7";
    map[KeyEvent.DOM_VK_F8] = "F8";
    map[KeyEvent.DOM_VK_F9] = "F9";
    map[KeyEvent.DOM_VK_F10] = "F10";
    map[KeyEvent.DOM_VK_F11] = "F11";
    map[KeyEvent.DOM_VK_F12] = "F12";
}

// Read the phrases that specify a next link
// by reading the preferences or defaults,
// populate the listbox with the phrases,
// and put the phrases in a lookup table.
function nextplease_initializeListBox (listboxId, prefName, map, defaultValues)
{
    var nextpleasePrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    var listbox = document.getElementById(listboxId);
    var tempprefname = prefName + '.expr0';
    if (nextpleasePrefs.prefHasUserValue(tempprefname))
	{
	    var i=0;
	    while (nextpleasePrefs.prefHasUserValue(tempprefname))
		{
		    var prefValue = nextplease_GetUnicharPref(nextpleasePrefs,tempprefname);
		    var values = prefValue.split("|");
		    for (var j=0; j<values.length; j++) 
			{
			    var phrase = values[j].replace(/&pipe;/g, "|");
			    if (phrase != '') {
				listbox.appendItem(phrase, phrase);

				// Scroll to the newly added item to workaround 
				// what I think is a Firefox bug. I was getting
				// Javascript exceptions when trying to read the
				// values at the bottom that are "hidden".
				listbox.ensureIndexIsVisible(listbox.getRowCount()-1);
				map[phrase] = true;
			    }
			}
		    i++;
		    tempprefname = prefName + '.expr' + i;
		}
	}
    else
	{
	    for (var i=0; i<defaultValues.length; i++)
		{
		    var phrase = defaultValues[i];
		    listbox.appendItem(phrase, phrase);
		    // Scroll to item to workaround Firefox bug.
		    listbox.ensureIndexIsVisible(i);
		    map[defaultValues[i]] = true;
		}
	}
    listbox.ensureIndexIsVisible(0);
}

function nextplease_InitModifier(prefs, prefname, elemId, defaultValue) 
{
    // Read the key binding prefs and set the dialog items appropriately
    if (prefs.prefHasUserValue(prefname))
    {
        document.getElementById(elemId).value = prefs.getCharPref(prefname);
    } 
    else 
    {
	// Special case check for setting prev modifier for upgraders
	// for version 0.5.x and earlier
	if ((prefs.prefHasUserValue('nextplease.keymodifier')) &&
	    (elemId == 'nextpleasePrevModifier'))
	    document.getElementById(elemId).value = prefs.getCharPref('nextplease.keymodifier');
	else
	    document.getElementById(elemId).value = defaultValue;
    }
}

function nextplease_InitKey(prefs, prefname, keyElemId, keyMenuElemId, defaultValue) 
{
    if (prefs.prefHasUserValue(prefname))
	{
	    if (KeyCodeToStringMap[prefs.getIntPref(prefname)])
		{
		    document.getElementById(keyElemId).value = '';
		    document.getElementById(keyMenuElemId).value = 
			KeyCodeToStringMap[prefs.getIntPref(prefname)];
		}
	    else
		{
		    document.getElementById(keyMenuElemId).value = '';
		    document.getElementById(keyElemId).value = 
			String.fromCharCode(prefs.getIntPref(prefname));
		}
	}
    else
	{
	    document.getElementById(keyMenuElemId).value = defaultValue;
	    document.getElementById(keyElemId).value = '';
	}
}

function nextplease_InitRegEx(prefs, prefname, elemId, defaultValue) 
{
    if (prefs.prefHasUserValue(prefname)) {
        var prefValue = nextplease_Trim(nextplease_GetUnicharPref(prefs, prefname));
        if (prefValue != '') {
  	    document.getElementById(elemId).value = 
  	        prefValue;
        } else {
 	    document.getElementById(elemId).value = defaultValue;
        }
    } else {
	document.getElementById(elemId).value = defaultValue;
    }
}

//Initialize options
function nextplease_initializeOptions()
{
    var nextpleasePrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");

    keyBindingsChanged = false;
    nextplease_initializeStringToKeyCodeMap(StringToKeyCodeMap);
    nextplease_initializeKeyCodeToStringMap(KeyCodeToStringMap);

    nextplease_initializeListBox ('nextfields', 'nextplease.nextphrase', NextPhrasesMap, DefaultNextPhrases);
    nextplease_initializeListBox ('prevfields', 'nextplease.prevphrase', PrevPhrasesMap, DefaultPrevPhrases);
    nextplease_initializeListBox ('firstfields', 'nextplease.firstphrase', FirstPhrasesMap, DefaultFirstPhrases);
    nextplease_initializeListBox ('lastfields', 'nextplease.lastphrase', LastPhrasesMap, DefaultLastPhrases);

    nextplease_initializeListBox ('nextimagefields', 'nextplease.nextimage', NextImagesMap, DefaultNextImages);
    nextplease_initializeListBox ('previmagefields', 'nextplease.previmage', PrevImagesMap, DefaultPrevImages);
    nextplease_initializeListBox ('firstimagefields', 'nextplease.firstimage', FirstImagesMap, DefaultFirstImages);
    nextplease_initializeListBox ('lastimagefields', 'nextplease.lastimage', LastImagesMap, DefaultLastImages);

    if (nextpleasePrefs.prefHasUserValue('nextplease.allowsubmit'))
    {
        document.getElementById('nextpleaseAllowSubmit').checked = nextpleasePrefs.getBoolPref('nextplease.allowsubmit');
    } 

    document.getElementById('nextpleaseAllowNumberShortcuts').checked = true;
    if (nextpleasePrefs.prefHasUserValue('nextplease.allownumbershortcuts'))
    {
        document.getElementById('nextpleaseAllowNumberShortcuts').checked = nextpleasePrefs.getBoolPref('nextplease.allownumbershortcuts');
    } 

    document.getElementById('nextpleaseAllowContextMenu').checked = true;
    if (nextpleasePrefs.prefHasUserValue('nextplease.allowcontextmenu'))
    {
        document.getElementById('nextpleaseAllowContextMenu').checked = nextpleasePrefs.getBoolPref('nextplease.allowcontextmenu');
    } 


    document.getElementById('nextpleaseAllowSmartNext').checked = false;
    if (nextpleasePrefs.prefHasUserValue('nextplease.allowsmartnext'))
    {
        document.getElementById('nextpleaseAllowSmartNext').checked = nextpleasePrefs.getBoolPref('nextplease.allowsmartnext');
    } 

    nextplease_InitModifier(nextpleasePrefs, 'nextplease.keymodifier', 
			    'nextpleaseModifier', 'CTRL+SHIFT');
    nextplease_InitModifier(nextpleasePrefs, 'nextplease.prevkeymodifier', 
			    'nextpleasePrevModifier', 'CTRL+SHIFT');
    nextplease_InitModifier(nextpleasePrefs, 'nextplease.firstkeymodifier', 
			    'nextpleaseFirstModifier', 'CTRL+SHIFT');
    nextplease_InitModifier(nextpleasePrefs, 'nextplease.lastkeymodifier', 
			    'nextpleaseLastModifier', 'CTRL+SHIFT');

    nextplease_InitKey(nextpleasePrefs, 'nextplease.nextkey', 'nextkey', 
		       'nextkeymenu', 'Right Arrow');
    nextplease_InitKey(nextpleasePrefs, 'nextplease.prevkey', 'prevkey', 
		       'prevkeymenu', 'Left Arrow');
    nextplease_InitKey(nextpleasePrefs, 'nextplease.firstkey', 'firstkey', 
		       'firstkeymenu', 'Up Arrow');
    nextplease_InitKey(nextpleasePrefs, 'nextplease.lastkey', 'lastkey', 
		       'lastkeymenu', 'Down Arrow');

    nextplease_InitRegEx(nextpleasePrefs, 'nextplease.nextregex',
			 'nextRegEx', DefaultNextRegEx);
    nextplease_InitRegEx(nextpleasePrefs, 'nextplease.prevregex',
			 'prevRegEx', DefaultPrevRegEx);
    nextplease_InitRegEx(nextpleasePrefs, 'nextplease.firstregex',
			 'firstRegEx', DefaultFirstRegEx);
    nextplease_InitRegEx(nextpleasePrefs, 'nextplease.lastregex',
			 'lastRegEx', DefaultLastRegEx);
    nextplease_InitRegEx(nextpleasePrefs, 'nextplease.galleryregex',
			 'galleryRegEx', DefaultGalleryRegEx);
}

function nextplease_SaveKeyPref (prefs, prefname,keyId, keyMenuId ) 
{
    //var keyString = nextplease_Trim(document.getElementById(keyId).value);
    var keyString = document.getElementById(keyId).value;
    if (keyString == '') {
	prefs.setIntPref(prefname, StringToKeyCodeMap[document.getElementById(keyMenuId).value]);
    } else {
	if (!nextplease_isAlpha(keyString))
	    return false;
	var curCharCode = keyString.toUpperCase().charCodeAt(0);
	prefs.setIntPref(prefname, curCharCode);
    }
}

// Save the listbox items specified by listboxId into 
// the preference specified by prefs and prefbranchname
function nextplease_SaveListboxPrefs (listboxId, prefs, prefbranchname) 
{
    var listbox = document.getElementById(listboxId);
    var numRows = listbox.getRowCount();
    prefs.deleteBranch(prefbranchname + '.');
    var tempstr= "";
    for (var i=0; i<numRows; i++)
	{
	    tempstr = tempstr + "|" + listbox.getItemAtIndex(i).value.replace(/\|/g, "&pipe;");
	}
    nextplease_SetUnicharPref(prefs, prefbranchname + '.expr0', 
		   tempstr);
}

// Write out the preferences from the dialog.
function nextplease_saveOptions()
{
    var nextpleasePrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("");
 
    nextpleasePrefs.setCharPref('nextplease.keymodifier', document.getElementById('nextpleaseModifier').value);
    nextpleasePrefs.setCharPref('nextplease.prevkeymodifier', document.getElementById('nextpleasePrevModifier').value);
    nextpleasePrefs.setCharPref('nextplease.firstkeymodifier', document.getElementById('nextpleaseFirstModifier').value);
    nextpleasePrefs.setCharPref('nextplease.lastkeymodifier', document.getElementById('nextpleaseLastModifier').value);

    nextplease_SaveKeyPref(nextpleasePrefs, 'nextplease.nextkey', 
			   'nextkey', 'nextkeymenu');
    nextplease_SaveKeyPref(nextpleasePrefs, 'nextplease.prevkey', 
			   'prevkey', 'prevkeymenu');
    nextplease_SaveKeyPref(nextpleasePrefs, 'nextplease.lastkey', 
			   'lastkey', 'lastkeymenu');
    nextplease_SaveKeyPref(nextpleasePrefs, 'nextplease.firstkey', 
			   'firstkey', 'firstkeymenu');

    nextplease_SaveListboxPrefs ('nextfields',  nextpleasePrefs, 'nextplease.nextphrase');
    nextplease_SaveListboxPrefs ('prevfields',  nextpleasePrefs, 'nextplease.prevphrase');
    nextplease_SaveListboxPrefs ('firstfields', nextpleasePrefs, 'nextplease.firstphrase');
    nextplease_SaveListboxPrefs ('lastfields',  nextpleasePrefs, 'nextplease.lastphrase');

    nextplease_SaveListboxPrefs ('nextimagefields',  nextpleasePrefs, 'nextplease.nextimage');
    nextplease_SaveListboxPrefs ('previmagefields',  nextpleasePrefs, 'nextplease.previmage');
    nextplease_SaveListboxPrefs ('firstimagefields', nextpleasePrefs, 'nextplease.firstimage');
    nextplease_SaveListboxPrefs ('lastimagefields',  nextpleasePrefs, 'nextplease.lastimage');

    nextpleasePrefs.setBoolPref('nextplease.allowsubmit',
				document.getElementById("nextpleaseAllowSubmit").checked);

    nextpleasePrefs.setBoolPref('nextplease.allownumbershortcuts',
				document.getElementById("nextpleaseAllowNumberShortcuts").checked);
    nextpleasePrefs.setBoolPref('nextplease.allowcontextmenu',
				document.getElementById("nextpleaseAllowContextMenu").checked);
    nextpleasePrefs.setBoolPref('nextplease.allowsmartnext',
				document.getElementById("nextpleaseAllowSmartNext").checked);




    nextplease_SetUnicharPref(nextpleasePrefs, 'nextplease.nextregex',
		   document.getElementById('nextRegEx').value);
    nextplease_SetUnicharPref(nextpleasePrefs, 'nextplease.prevregex',
		   document.getElementById('prevRegEx').value);
    nextplease_SetUnicharPref(nextpleasePrefs, 'nextplease.firstregex',
		   document.getElementById('firstRegEx').value);
    nextplease_SetUnicharPref(nextpleasePrefs, 'nextplease.lastregex',
		   document.getElementById('lastRegEx').value);
    nextplease_SetUnicharPref(nextpleasePrefs, 'nextplease.galleryregex',
		   document.getElementById('galleryRegEx').value);

    if (keyBindingsChanged)
	alert("Changes to key binding will only take effect in new windows or after restarting Firefox.");
    else
	alert("To make changes take effect, run 'Next, Please' once either through the context menu or the old shortcut.");
	

}

function nextplease_OnModifierMenuChange(keyId, menuKeyId, keyModifierId)
{
    var keyElem = document.getElementById(keyId);
    var keyMenuElem = document.getElementById(menuKeyId);
    var keyModifierElem = document.getElementById(keyModifierId);

    var nextElem = document.getElementById('nextkey');
    var prevElem = document.getElementById('prevkey');
    var firstElem = document.getElementById('firstkey');
    var lastElem = document.getElementById('lastkey');

    var nextMenuElem = document.getElementById('nextkeymenu');
    var prevMenuElem = document.getElementById('prevkeymenu');
    var firstMenuElem = document.getElementById('firstkeymenu');
    var lastMenuElem = document.getElementById('lastkeymenu');

    var nextModifierElem  = document.getElementById('nextpleaseModifier');
    var prevModifierElem  = document.getElementById('nextpleasePrevModifier');
    var firstModifierElem = document.getElementById('nextpleaseFirstModifier');
    var lastModifierElem  = document.getElementById('nextpleaseLastModifier');

    if ((keyModifierElem != nextModifierElem) &&
	(keyModifierElem.value == nextModifierElem.value) &&
	(keyElem.value.toUpperCase() == nextElem.value.toUpperCase()) &&
	(keyMenuElem.value == nextMenuElem.value)) 
	{
	    keyElem.value = "";
	    keyMenuElem.value = "";
	}

    if ((keyModifierElem != prevModifierElem) &&
	(keyModifierElem.value == prevModifierElem.value) &&
	(keyElem.value.toUpperCase() == prevElem.value.toUpperCase()) &&
	(keyMenuElem.value == prevMenuElem.value)) 
	{
	    keyElem.value = "";
	    keyMenuElem.value = "";
	}

    if ((keyModifierElem != firstModifierElem) &&
	(keyModifierElem.value == firstModifierElem.value) &&
	(keyElem.value.toUpperCase() == firstElem.value.toUpperCase()) &&
	(keyMenuElem.value == firstMenuElem.value)) 
	{
	    keyElem.value = "";
	    keyMenuElem.value = "";
	}

    if ((keyModifierElem != lastModifierElem) &&
	(keyModifierElem.value == lastModifierElem.value) &&
	(keyElem.value.toUpperCase() == lastElem.value.toUpperCase()) &&
	(keyMenuElem.value == lastMenuElem.value)) 
	{
	    keyElem.value = "";
	    keyMenuElem.value = "";
	}
	

    keyBindingsChanged = true;
    return true;
}

function nextplease_OnMenuChange(keyId, menuKeyId, keyModifierId)
{
    // Ensure that key and keymenu do not both
    // have an entry
    var keyElem = document.getElementById(keyId);
    var keyMenuElem = document.getElementById(menuKeyId);
    var keyModifierElem = document.getElementById(keyModifierId);
    if (keyMenuElem.value != '') 
	{
	    keyElem.value = "";
	}

    var nextMenuElem = document.getElementById('nextkeymenu');
    var prevMenuElem = document.getElementById('prevkeymenu');
    var firstMenuElem = document.getElementById('firstkeymenu');
    var lastMenuElem = document.getElementById('lastkeymenu');

    var nextModifierElem  = document.getElementById('nextpleaseModifier');
    var prevModifierElem  = document.getElementById('nextpleasePrevModifier');
    var firstModifierElem = document.getElementById('nextpleaseFirstModifier');
    var lastModifierElem  = document.getElementById('nextpleaseLastModifier');

    if ((keyMenuElem != nextMenuElem) && (keyMenuElem.value == nextMenuElem.value) && 
	(keyModifierElem.value == nextModifierElem.value))
	nextMenuElem.value = "";
    if ((keyMenuElem != prevMenuElem) && (keyMenuElem.value == prevMenuElem.value) && 
	(keyModifierElem.value == prevModifierElem.value))
	prevMenuElem.value = "";
    if ((keyMenuElem != firstMenuElem) && (keyMenuElem.value == firstMenuElem.value) && 
	(keyModifierElem.value == firstModifierElem.value))
	firstMenuElem.value = "";
    if ((keyMenuElem != lastMenuElem) && (keyMenuElem.value == lastMenuElem.value) && 
	(keyModifierElem.value == lastModifierElem.value))
	lastMenuElem.value = "";
    
    keyBindingsChanged = true;
    return true;
}

function nextplease_OnKeyChange(keyId, menuKeyId, keyModifierId)
{
    var keyElem = document.getElementById(keyId);
    var keyModifierElem = document.getElementById(keyModifierId);
    if (!nextplease_isAlpha(keyElem.value)) {
	keyElem.value = '';
	alert('You can only use A-Z for this field.');
	return false;
    }

    // Ensure that key and keymenu do not both
    // have an entry
    if (keyElem.value != '') 
	{
	    document.getElementById(menuKeyId).value = "";
	}

    var nextElem = document.getElementById('nextkey');
    var prevElem = document.getElementById('prevkey');
    var firstElem = document.getElementById('firstkey');
    var lastElem = document.getElementById('lastkey');

    var nextModifierElem  = document.getElementById('nextpleaseModifier');
    var prevModifierElem  = document.getElementById('nextpleasePrevModifier');
    var firstModifierElem = document.getElementById('nextpleaseFirstModifier');
    var lastModifierElem  = document.getElementById('nextpleaseLastModifier');

    if ((keyElem != nextElem) && (nextElem.value.toUpperCase() == keyElem.value.toUpperCase()) &&
	(keyModifierElem.value == nextModifierElem.value))
	nextElem.value = "";
    if ((keyElem != prevElem) && (prevElem.value.toUpperCase() == keyElem.value.toUpperCase()) &&
	(keyModifierElem.value == prevModifierElem.value))
	prevElem.value = "";
    if ((keyElem != firstElem) && (firstElem.value.toUpperCase() == keyElem.value.toUpperCase()) &&
	(keyModifierElem.value == firstModifierElem.value))
	firstElem.value = "";
    if ((keyElem != lastElem) && (lastElem.value.toUpperCase() == keyElem.value.toUpperCase()) &&
	(keyModifierElem.value == lastModifierElem.value))
	lastElem.value = "";

    keyBindingsChanged = true;
    return true;
}

// Add the an item from the field to the listbox specified by listboxId
function nextplease_AddToListbox(newElemFieldId, listboxId, map)
{
    var newElemString = nextplease_Trim(document.getElementById(newElemFieldId).value);

    if (newElemString != '')
	{
	    if(map[newElemString])
		alert("'" + newElemString + "' is already in the list.");
	    else if(!map[newElemString])
		{
		    var listbox = document.getElementById(listboxId);
		    listbox.appendItem(newElemString, newElemString);
		    map[newElemString] = true;
		    listbox.ensureIndexIsVisible(listbox.getRowCount()-1);
		}
	}
}

// Remove the selected item from the listbox specified by listboxId
function nextplease_RemoveSelectedFromListbox(listboxId, map)
{
    var listbox = document.getElementById(listboxId);

    var selected = listbox.selectedIndex;
    if (selected >= 0)
	{
	    map[listbox.selectedItem.value] = false;
	    listbox.removeItemAt(selected);
	}

}

function nextplease_RestoreDefault(elementId, defaultString)
{
    document.getElementById(elementId).value = defaultString;
}


